using OpenCLRefinements if RUBY_VERSION.scan(/\d+/).collect(&:to_i).first >= 2

require_relative 'motion_estimation'

module OpenCL

  DEVICE_ME_VERSION_INTEL = 0x407E

  ME_CHROMA_INTRA_PREDICT_ENABLED_INTEL = 0x1
  ME_LUMA_INTRA_PREDICT_ENABLED_INTEL = 0x2

  ME_SKIP_BLOCK_TYPE_16x16_INTEL = 0x0
  ME_SKIP_BLOCK_TYPE_8x8_INTEL = 0x4

  ME_COST_PENALTY_NONE_INTEL = 0x0
  ME_COST_PENALTY_LOW_INTEL = 0x1
  ME_COST_PENALTY_NORMAL_INTEL = 0x2
  ME_COST_PENALTY_HIGH_INTEL = 0x3

  ME_COST_PRECISION_QPEL_INTEL = 0x0
  ME_COST_PRECISION_HEL_INTEL = 0x1
  ME_COST_PRECISION_PEL_INTEL = 0x2
  ME_COST_PRECISION_DPEL_INTEL = 0x3

  ME_LUMA_PREDICTOR_MODE_VERTICAL_INTEL = 0x0
  ME_LUMA_PREDICTOR_MODE_HORIZONTAL_INTEL = 0x1
  ME_LUMA_PREDICTOR_MODE_DC_INTEL = 0x2
  ME_LUMA_PREDICTOR_MODE_DIAGONAL_DOWN_LEFT_INTEL = 0x3

  ME_LUMA_PREDICTOR_MODE_DIAGONAL_DOWN_RIGHT_INTEL = 0x4
  ME_LUMA_PREDICTOR_MODE_PLANE_INTEL = 0x4
  ME_LUMA_PREDICTOR_MODE_VERTICAL_RIGHT_INTEL = 0x5
  ME_LUMA_PREDICTOR_MODE_HORIZONTAL_DOWN_INTEL = 0x6
  ME_LUMA_PREDICTOR_MODE_VERTICAL_LEFT_INTEL = 0x7
  ME_LUMA_PREDICTOR_MODE_HORIZONTAL_UP_INTEL = 0x8

  ME_CHROMA_PREDICTOR_MODE_DC_INTEL = 0x0
  ME_CHROMA_PREDICTOR_MODE_HORIZONTAL_INTEL = 0x1
  ME_CHROMA_PREDICTOR_MODE_VERTICAL_INTEL = 0x2
  ME_CHROMA_PREDICTOR_MODE_PLANE_INTEL = 0x3

  ME_VERSION_LEGACY_INTEL = 0x0
  ME_VERSION_ADVANCED_VER_1_INTEL = 0x1
  ME_VERSION_ADVANCED_VER_2_INTEL = 0x2

  ME_FORWARD_INPUT_MODE_INTEL = 0x1
  ME_BACKWARD_INPUT_MODE_INTEL = 0x2
  ME_BIDIRECTION_INPUT_MODE_INTEL = 0x3

  ME_BIDIR_WEIGHT_QUARTER_INTEL = 0x10
  ME_BIDIR_WEIGHT_THIRD_INTEL = 0x15
  ME_BIDIR_WEIGHT_HALF_INTEL = 0x20
  ME_BIDIR_WEIGHT_TWO_THIRD_INTEL = 0x2B
  ME_BIDIR_WEIGHT_THREE_QUARTER_INTEL = 0x30

  class Device
    ME_VERSION_INTEL = 0x407E
    module AdvanceMotionEstimationINTEL
      extend InnerGenerator
      get_info("Device", :cl_uint, "me_version_intel")

    end
    register_extension( :cl_intel_advanced_motion_estimation, AdvanceMotionEstimationINTEL, "platform.extensions.include?(\"cl_intel_advanced_motion_estimation\")" )
  end
end
